*
* Shared format routine: _format_(char *output, int *arg_ptr)
*
_format_ LDY	2,SP		Y = pointer to arguments
	LDX	2,-Y		X = format string
	STY	2,SP		Save for later
* Process next character from format string
?1	LDAA	1,X+		Get character from string
	CMPA	#'%'		Format specifier?
	BEQ	?2		Yes, handle it
* Non-format, copy to string
	LDY	4,SP		Get output pointer
	STAA	1,Y+		Write it
	STY	4,SP		Resave it
	TSTA			End of string?
	BNE	?1		No, proceed
	RTS
* Test for '-' (Left justify)
?2	LDAA	,X		Get next char
	LDAB	#' '		Assume space
	CMPA	#'-'		Left justify?
	BNE	?3		No, its OK
	ORAB	#%10000000	Set LJ flag
	LDAA	1,+X		Get next char
* Test for leading '0' (zero fill)
?3	CMPA	#'0'		Zero fill?
	BNE	?4		No, its OK
	ORAB	#'0'		Convert to ZF
?4	STAB	?temp		Save flags
	CLRB			Zero width
* Evaluate field width
?5	LDAA	1,X+		Get char
	SUBA	#'0'		Convert
	CMPA	#10		In range?
	BHS	?6		No, end
	PSHA			Save it
	LDAA	#10		X10
	MUL			B=B*10
	ADDB	1,SP+		Add in digit
	BRA	?5		Proceed
* Interpret the format specifier
?6	STAB	?temp+1		Save width
	LDY	2,SP		Get pointer to args
	LDD	2,-Y		Get value
	STY	2,SP		Resave
	TFR	D,Y		Y = argument value
	LDAA	-1,X		Get char back
	PSHX			Save format string
	LDX	6,SP		Get output pointer
* 'b' Binary number
	LDAB	#2		Base 2
	CMPA	#'b'		Binary output?
	BEQ	?8		Yes, do it
* 'o' Octal number
	LDAB	#8		Base 8
	CMPA	#'o'		Octal output?
	BEQ	?8		Yes, do it
* 'x' hexidecimal number
	LDAB	#16		Base 16
	CMPA	#'x'		Hex output?
	BEQ	?8		Yes, do it
* 'u' unsigned number
	CMPA	#'u'		Unsigned number?
	BEQ	?7		Yes, do it
* 'd' decimal number
	CMPA	#'d'		Decimal number?
	BNE	?20		No, try next
	TFR	Y,D		D = value
	TSTA			Negative?
	BPL	?7		No, its OK
	COMA			Convert to
	COMB			Negative
	ADDD	#1		of value
	TFR	D,Y		Resave
	LDAA	#'-'		Minus size
	STAA	1,X+		Write to output
	STX	6,SP		Save adjusted value
	LDAB	?temp+1		Get field
	BEQ	?7		Fixed length
	DEC	?temp+1		Reduce width
?7	LDAB	#10		Base 10 output
* Output number in Y using base in B
?8	CLRA			Zero initial width
	PSHA			Save marker
* Process value & stack digits (in reverse order)
?9	TFR	D,X		Save base count/value
	CLRA			Zero high
	JSR	?mod		D = value % base, Y = value / base
	ADDB	#'0'		Convert to ASCII
	CMPB	#'9'		in range?
	BLS	?10		Its OK
	ADDB	#7		Convert
?10	PSHB			Save value
	TFR	X,D		Get count/base
	INCA			Advance count
	CPY	#0		More digits?
	BNE	?9		Yes, continue output
	ADDA	#7		Offset to stack
	LDX	A,SP		Get output pointer
	SUBA	#7		Re-adjust length
* Unstack digits into output buffer
	JSR	?40		Left fill if necessary
?11	LDAB	1,SP+		Get char
	BEQ	?12		End of line
	STAB	1,X+		write to output
	BRA	?11		Keep going
?12	TST	?temp		Left justify?
	BPL	?13		No, don't PAD
	JSR	?50		Right fill
?13	STX	6,SP		Resave output ptr
	PULX			Restore format string
	JMP	?1		And get next
* 's' string
?20	CMPA	#'s'		String output?
	BNE	?30		No, try next
	PSHY			Save pointer to string
	LDAA	#-1		Initial count
?21	INCA			Advance count
	LDAB	1,Y+		Test and advance
	BNE	?21		Go till end of string
	PULY			Restore pointer to string
	JSR	?40		Left fill if necessary
?22	LDAB	1,Y+		Get char
	BEQ	?12		End of string
	STAB	1,X+		Write in output buffer
	BRA	?22		And continue
*'c' Character
?30	TFR	A,B		Copy character
	CMPA	#'c'		Character output?
	BNE	?31		No, use character
	TFR	Y,D		'B' = character
?31	LDAA	#1		Width=1
	JSR	?40		Left fill if necessary
	STAB	1,X+		Write output
	BRA	?12		And proceed
*
* Pad the field assuming width in A
*
?40	TST	?temp		Left justify?
	BPL	?50		No, pad
	RTS
?50	PSHD			Save width
	LDAB	?temp+1		Fixed field?
	BEQ	?53		No, exit
	LDAA	?temp		Get flags
	ANDA	#%00111111	Save only ' ' or '0'
?52	CMPB	,SP		Are we over?
	BLS	?53		Yes, exit
	STAA	1,X+		Fill one char
	DECB			Reduce count
	BRA	?52		And proceed
?53	PULD			Restore
	RTS
