*
* DDS MICRO-C 68HC12 Serial I/O routines
* These use the SCI0 port (Status=?REGS+$C4, Data=?REGS+$C7)
*
* Write a string to the console: putstr(char *string)
putstr	LDX	2,SP		Get string address
?putstr	LDAB	1,X+		Get character
	BEQ	?1		End, exit
	BSR	?putch		Write the character
	BRA	?putstr		And proceed
* Write character to console - Translate newlines: putch(char c)
putch	LDD	2,SP		Get char to write
?putch	CMPB	#$0A		Newline?
	BNE	?putchr		No, write it
	BSR	?putchr		Write it
	LDAB	#$0D		Get return
	BRA	?putchr		Write & exit
* Write character to console - Raw format
putchr	LDD	2,SP		Get char to write
?putchr	BRCLR	?REGS+$C4;%10000000;*
	STAB	?REGS+$C7	Write character
?1	RTS
* Check for character - Raw format
chkchr	BRSET	?REGS+$C4;%00100000;getchr If char, get it
	LDD	#-1		Return -1
	RTS
* Check for character
chkch	CLRA			Zero default result
	CLRB			Zero default result
	BRCLR	?REGS+$C4;%00100000;?1
* Read character from console - Translate Returns
getch	BSR	getchr		Get character
	CMPB	#$0D		Return?
	BNE	?1		Its OK
	LDAB	#$0A		Convert to newline
	RTS
* Read character from console - Raw format
getchr	BRCLR	?REGS+$C4;%00100000;* Wait for character
	LDAB	?REGS+$C7	Read the character
	CLRA			Zero high
	RTS
* Read a string (with editing) from the console: getstr(buffer, length)
getstr	LDY	4,SP		Get buffer
	LDX	#0		Starting length is zero
?2	BSR	getch		Get a character
	CMPB	#$7F		Delete?
	BEQ	?3		Yes, handle it
	CMPB	#$08		Backspace?
	BEQ	?3		Yes, handle it
	CMPB	#$0A		Enter?
	BEQ	?4		Yes, handle it
	CPX	2,SP		Are we within length?
	BHS	?2		No, ignore
	STAB	1,Y+		Write to buffer
	INX			Advance length
	BSR	?putchr		Echo character to console
	BRA	?2		And proceed
?3	CPX	#0		Any data in buffer?
	BEQ	?2		No, ignore
	LDAB	#$08		Backspace
	BSR	?putchr		Echo
	LDAB	#' '		Overwrite with space
	BSR	?putchr		Echo
	LDAB	#$08		Backspace
	BSR	?putchr		Echo
	DEX			Backup count
	DEY			Backup in buffer
	BRA	?2		And proceed
?4	CLR	,Y		Zero end of buffer
	BSR	?putch		New line on console
	TFR	X,D		Report # chars received
	RTS
